{% extends "application.html" %}
{% block style %}
    <meta name="csrf-token" content="{{ csrf_token() }}">

    <link href='{{ url_for("static", filename="css/sweetalert2.min.css") }}' rel='stylesheet'/>
    <style>
    </style>
{% endblock %}
{% block content %}
    <div class="container-fluid">
        <div class="row d-flex justify-content-between">
            <h1 class="h3 mb-2 text-gray-800">Danh sách hẹn khám bệnh</h1>
            <a href="{{ url_for('PatientAppointment.create') }}">
                <button class="btn btn-primary">Tạo mới</button>
            </a>
        </div>
        <div class="card shadow mb-4">
            <div class="card-header py-3">
                <div class="row">
                    <div class="col-md-6">
                        <h6 class="m-0 font-weight-bold text-primary">
                            Danh sách lịch hẹn
                        </h6>
                    </div>
                    <div class="col-md-6">
                        <form class="user" action="{{ url_for('PatientAppointment.index') }}" type="search">
                            <input type="text" hidden value="{{ csrf_token() }}" name="csrf_token">
                            <input type="text" class="form-control form-control-user" name="search"
                                   placeholder="Search">
                        </form>
                    </div>
                </div>

            </div>
            <div class="card-body">
                <div class="table-responsive">
                    <table class="table table-bordered" id="dataTable" width="100%" cellspacing="0">
                        <thead>
                        <tr>
                            <th scope="col">#</th>
                            <th scope="col">Tên bác sĩ</th>
                            <th scope="col" class="text-center">Thời gian bắt đầu</th>
                            <th scope="col" class="text-center">Trạng thái</th>
                            <th scope="col" class="text-center">Hành động</th>
                        </tr>
                        </thead>

                        <tbody>

                        {% for item in appointment %}
                            <tr>
                                <td>{{ loop.index }}</td>
                                <td>{{ item.doctor.name }}</td>
                                <td>{{ item.time_start | datetime }}</td>
                                <td class="text-center" id="date_start_{{ loop.index }}"
                                    data-value="{{ item.time_start }}">
                                    {% if item.status==0 %}
                                        <span id="cancel-{{ item.id }}">Đã hết hiệu lực</span>
                                    {% else %}
                                        <span id="active-{{ item.id }}">Còn hiệu lực</span>
                                    {% endif %}
                                </td>
                                <td class="text-center" id="btn_check_{{ loop.index }}">
                                    {% if item.status==1 %}
                                        <a id="btn-{{ item.id }}" href="#" onclick="openReasonPopup({{ item.id }})">
                                            <button class="btn btn-sm btn-danger">
                                                Hủy
                                            </button>
                                        </a>
                                    {% endif %}
                                    {% if item.status==1 %}
                                        <a href="{{ url_for('PatientAppointment.edit', id=item.id) }}">
                                            <button class="btn btn-sm btn-primary">
                                                Chỉnh sửa
                                            </button>
                                        </a>
                                    {% endif %}
                                </td>
                            </tr>
                        {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
        <div class="d-flex justify-content-center">
            {{ pagination.links }}
        </div>
    </div>
{% endblock %}

{% block script %}
    <script src='{{ url_for("static", filename="js/sweetalert2.all.min.js") }}'></script>
    <script>
        $(document).ready(function () {
            for (var i = 1; i <= 10; i++) {
                var date_start_id = document.getElementById('date_start_' + i);
                var btn_check_id = document.getElementById('btn_check_' + i);
                if (date_start_id) {
                    var cookieValue = date_start_id.getAttribute('data-value');
                    var dateStart = new Date(cookieValue);
                    var dateNow = new Date();
                    if (dateNow > dateStart){
                        date_start_id.innerHTML = "Đã hết hiệu lực";
                        btn_check_id.innerHTML = "";
                    }
                }
            }
        });
        var csrftoken = $('meta[name=csrf-token]').attr('content');

        $.ajaxSetup({
            beforeSend: function (xhr, settings) {
                if (!/^(GET|HEAD|OPTIONS|TRACE)$/i.test(settings.type)) {
                    xhr.setRequestHeader("X-CSRFToken", csrftoken)
                }
            }
        });

        function openReasonPopup(id) {
            Swal.fire({
                title: "Thông điệp",
                input: 'text',
                inputAttributes: {
                    autocapitalize: 'off'
                },
                showCancelButton: true,
                confirmButtonText: 'Gửi',
                cancelButtonText: 'Hủy',
                showLoaderOnConfirm: true,
                preConfirm: (data) => {
                    $.ajax({
                        url: "/patient/ajax/appointment/delete",
                        type: "POST",
                        credentials: 'include',
                        contentType: "application/json",
                        data: JSON.stringify({
                            id: id,
                            content: data,
                        }),
                        dataType: "json",
                    }).done(function (response) {
                        $('#btn-' + id).hide();
                        $('#active-' + id).text("Đã bị hoãn");
                        location.reload();
                        toastr.success(response.message, response.status);
                    }).fail(function (response) {
                        toastr.error("Có lối xảy ra");
                    });
                },
                allowOutsideClick: () => !Swal.isLoading()
            })
        }
    </script>
{% endblock %}